﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System;

public class sounds : MonoBehaviour
{
    int objno = 0;
    rtcmixmain RTcmix;
    private bool did_start = false;

    float beeptime;


    private void Awake()
    {
        // find the RTcmixmain object with the RTcmix function definitions
        RTcmix = GameObject.Find("RTcmixmain").GetComponent<rtcmixmain>();
    }


    // Use this for initialization
    void Start()
    {
        // initialize RTcmix
        RTcmix.initRTcmix(objno);

        // set up the RTcmix variables "tty", "beep1", etc. to hold the
        // string pointing to the soundfile in ghe Assets/sf directory
        String score = "tty = \"" + Application.dataPath + "/sf/tty.wav\" " +
            "beep1 = \"" + Application.dataPath + "/sf/beep1.wav\" " +
            "beep2 = \"" + Application.dataPath + "/sf/beep2.wav\" " +
            "beep3 = \"" + Application.dataPath + "/sf/beep3.wav\" ";
        RTcmix.SendScore(score, objno);
        // randomly set a time to trigger a 'beep' from the current Time.time
        beeptime = Time.time + UnityEngine.Random.Range(1.0f, 5.0f);

        score = "rtinput(tty) " +
            "dur = 15 " +
            "amp = 1 " +
            "ampenv = maketable(\"line\", 1000, 0,0, 3,1, 12,1, 15,0) " +
            "MIX(0, 0, dur, amp*ampenv, 0, 1) " +
            "MAXBANG(10) ";
        RTcmix.SendScore(score, objno);

        did_start = true;
    }

    // Update is called once per frame
    void Update()
    {
        if (Time.time > beeptime) {
            // trigger a 'beep'
            String score = "dice = random() " +
                "if (dice < 0.3) " +
                "   rtinput(beep1) " +
                "else if (dice < 0.6) " +
                "   rtinput(beep2) " +
                "else " +
                "   rtinput(beep3) " +
                "MIX(0, 0, 0.2, 1, 0, 1) ";
            RTcmix.SendScore(score, objno);
            // choose the next time from current Time.time to do a beep
            beeptime = Time.time + UnityEngine.Random.Range(1.0f, 5.0f);
        }
        
    }

    void OnAudioFilterRead(float[] data, int channels)
    {
        if (!did_start) return;

        // compute sound samples
        RTcmix.runRTcmix(data, objno, 0);

        if (RTcmix.checkbangRTcmix(objno) == 1) {
            String score = "rtinput(tty) " + 
                "MIX(0, 0, dur, amp*ampenv, 0, 1) " +
                "MAXBANG(10) ";
            RTcmix.SendScore(score, objno);
        }
    }


    void OnApplicationQuit()
    {
        did_start = false;
        RTcmix = null;
    }
}
